Package: microRNA
Version: 1.68.0
Author: R. Gentleman, S. Falcon
Title: Data and functions for dealing with microRNAs
Description: Different data resources for microRNAs and some functions
        for manipulating them.
License: Artistic-2.0
Maintainer: "Michael Lawrence" <lawremi@gmail.com>
Imports: Biostrings (>= 2.11.32)
Depends: R (>= 2.10)
biocViews: Infrastructure, GenomeAnnotation, SequenceMatching
git_url: https://git.bioconductor.org/packages/microRNA
git_branch: RELEASE_3_22
git_last_commit: ff3bb2e
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: yes
Packaged: 2025-10-30 05:04:32 UTC; biocbuild

 ### USAGE: go to the data directory and source this script...
 ### ie.  source("../inst/extdata/targetGen.R")
 ### If you extend it to other species, don't forget that you will have to also add man pages for the other data structures you make.


### Generic preprocessing of the file
hmat = read.delim("../../targetData/v5.txt.homo_sapiens", header = TRUE, skip=3, sep = "\t")
mmat = read.delim("../../targetData/v5.txt.mus_musculus", header = TRUE, skip=3, sep = "\t")


### Generic filtering function
testSpec = function(x, str){
     if(length(grep(str,as.character(x)))>0){
         1 }
     else { 0 }
}

#Process human
hsInd = apply(hmat, 1, function(x) testSpec(x, str ="hsa-miR"))

hsMat = hmat[hsInd>0,]
hsMat = as.matrix(hsMat)

## hsMap = list()
## hsMap = hsMat[,12]
## names(hsMap) = hsMat[,2]
##library(Biobase)
## hsTargets = list2env(as.list(hsMap))
## hsTargets = hsMap

hsTargets = data.frame(name = hsMat[,"SEQ"], target = hsMat[,"TRANSCRIPT_ID"], chrom = hsMat[,"CHR"], start = hsMat[,"START"], end = hsMat[,"END"], strand = hsMat[,"STRAND"])

rownames(hsTargets) = NULL 

save(hsTargets, file = "hsTargets.rda")



#Process mouse
mmInd = apply(mmat, 1, function(x) testSpec(x, str ="mmu-miR"))

mmMat = mmat[mmInd>0,]
mmMat = as.matrix(mmMat)

## mmMap = list()
## mmMap = mmMat[,12]
## names(mmMap) = mmMat[,2]
## ## mmTargets = list2env(as.list(mmMap))
## mmTargets = mmMap

mmTargets = data.frame(name = mmMat[,"SEQ"], target = mmMat[,"TRANSCRIPT_ID"], chrom = mmMat[,"CHR"], start = mmMat[,"START"], end = mmMat[,"END"], strand = mmMat[,"STRAND"])

rownames(mmTargets) = NULL

save(mmTargets, file = "mmTargets.rda")

## sample script that computes the maximum ``sequence similarity''
## between each non-human miRNA in miRBase and human miRNAs.


library(Biostrings)

read.fa <- function(file)
{
    mirna <- readFASTA(file, strip.desc = TRUE)
    mirna.seqs <- sapply(mirna, "[[", "seq")
    names(mirna.seqs) <-
        sapply(strsplit(sapply(mirna, "[[", "desc"), " "), "[", 1)
    mirna.seqs
}

fa.file <- "miRBase-12.0-mature.fa.gz"

if (!file.exists(fa.file))
    download.file("ftp://ftp.sanger.ac.uk/pub/mirbase/sequences/12.0/mature.fa.gz",
                  destfile = fa.file)


##mirna.seqs <- read.fa("miRBase-12.0-mature.fa")

mirna.seqs <- read.fa(gzfile(fa.file))

human.mirna <- mirna.seqs[substring(names(mirna.seqs), 1, 3) == "hsa"]
nonhuman.mirna <- mirna.seqs[substring(names(mirna.seqs), 1, 3) != "hsa"]


sim.with.human <-
    function(pattern, human.seqs = human.mirna,
             type = c("match", "align"), verbose = FALSE)
{
    type <- match.arg(type)
    sub.mat <-
        switch(type,
               match = {
                   ans <- matrix(-10000L, 4, 4,
                                 dimnames = list(c("A", "U", "C", "G"),
                                                 c("A", "U", "C", "G")))
                   diag(ans) <- 1L
                   ans
               },
               align = {
                   ans <- matrix(-1L, 4, 4,
                                 dimnames = list(c("A", "U", "C", "G"),
                                                 c("A", "U", "C", "G")))
                   diag(ans) <- 1L
                   ans
               })
    gap <- 
        switch(type,
               match = -10000L,
               align = -1L)
    sim <-
        pairwiseAlignment(human.seqs, pattern,
                          type = "local",
                          substitutionMatrix = sub.mat,
                          gapOpening = gap,
                          gapExtension = -10000L,
                          scoreOnly = FALSE)
    scores <- score(sim)
    w <- which.max(scores)
    if (verbose) {
        cat(sprintf("%s : %s -> %3g",
                    human.seqs[w], pattern, scores[w]),
            fill = TRUE)
        cat(paste(as.character(sim[w]), collapse = "\n"), fill = TRUE)
    }
    scores[w]
}


computeSimilarity <-
    function(query.seqs = nonhuman.mirna,
             target.seqs = human.mirna,
             ...)
{
    ans <- numeric(length(query.seqs))
    names(ans) <- names(query.seqs)
    ntot <- length(ans)
    for (i in seq_along(ans))
    {
        cat(sprintf("\r[%5g/%5g]", i, ntot))
        ans[i] <- 
            sim.with.human(query.seqs[i], target.seqs, ...)
    }
    ans
}


similarity.match <- 
    computeSimilarity(nonhuman.mirna,
                      human.mirna,
                      type = "match",
                      verbose = TRUE)

similarity.align <- 
    computeSimilarity(nonhuman.mirna,
                      human.mirna,
                      type = "align",
                      verbose = TRUE)

save(similarity.align, similarity.match,
     file = "similarity.rda")

.buildEl = function(s, r, minlen) {
    both = c(s, r)
    slen = nchar(s, type="chars")
    autoseqs = .Call(.longest_common_substring, both)
    if (all(nchar(autoseqs) < minlen))
        return(list())
    names(autoseqs) = autoseqs
    selfhybs = lapply(autoseqs,
      function(x) {
          locL = gregexpr(x, both, fixed=TRUE)
          starts = as.integer(locL[[1]]) # remove match.length attr
          mlen = attr(locL[[2]], "match.length")
          rcstarts = slen - (as.integer(locL[[2]]) + mlen - 1) + 1
          list(starts=starts, rcstarts=rcstarts)
          ## FIXME: add gap calculation here
      })
    ## FIXME: add base count/freq
    selfhybs
}

get_selfhyb_subseq = function(seq, minlen, type=c("RNA", "DNA")) {
    type = match.arg(type)
    revcompfun = switch(type,
      RNA=RNAStringSet,
      DNA=DNAStringSet,
      stop("type must be RNA or DNA"))
    rcSeq = reverseComplement(revcompfun(seq))
    rcSeq = as.character(rcSeq)
    ans = mapply(.buildEl, seq, rcSeq, minlen, USE.NAMES=FALSE)
    names(ans) = names(seq)
    ans
}

show_selfhyb_lengths = function(L) {
    lens = sapply(L, function(x) {
        if (length(x))
          nchar(names(x)[1], type="char")
        else
          0
    })
    table(lens, dnn="SHS length")
}

show_selfhyb_counts = function(L) {
    cnts = sapply(L, length)
    table(cnts, dnn="SHS counts")
}

 ### USAGE: go to the data directory and source this script...
 ### ie.  source("../inst/extdata/matSeqsGen.R")
 ### If you extend it to other species, don't forget that you will have to also add man pages for the other data structures you make.


 ### Generic preprocessing of the file
mat = read.delim("../inst/extdata/mature.fa", header = FALSE, sep = " ")

oInd = seq(1,dim(mat)[1],by=2)
eInd = seq(2,dim(mat)[1],by=2)

matO = mat[oInd,]
matE = mat[eInd,]

cMat = cbind(matO,matE)
cMat = cMat[,1:6]

fMat = apply(cMat, 1, function(x) gsub("^>","", x))
fMat = t(fMat)


 ### Generic filtering function
testSpec = function(x, str){
     if(length(grep(str,as.character(x)))>0){
         1 }
     else { 0 }
}



 ### Then Filter out the human rows
hsaDim = apply(fMat, 1, function(x) testSpec(x, str ="sapiens"))
hsaDim = as.vector(unlist(hsaDim))
hsaMat = fMat[hsaDim>0,]

 ### Make a list and save it:
hsSeqs = list()
hsSeqs = hsaMat[,6]
names(hsSeqs) = hsaMat[,1]

 ### Then just use the save() to save this thing as an .Rda file.
save(hsSeqs, file = "hsSeqs.rda")



 ### Then Filter out the mouse rows
mmuDim = apply(fMat, 1, function(x) testSpec(x, str ="musculus"))
mmuDim = as.vector(unlist(mmuDim))
mmuMat = fMat[mmuDim>0,]

 ### Make a list and save it:
mmSeqs = list()
mmSeqs = mmuMat[,6]
names(mmSeqs) = mmuMat[,1]

 ### Then just use the save() to save this thing as an .Rda file.
save(mmSeqs, file = "mmSeqs.rda")

 RNA2DNA = function(x) chartr("U", "T", toupper(x))

 seedRegions = function(x, start=2, stop=7)
	substr(x, start, stop)


 matchSeeds = function(seeds, seqs) {
        m1 = lapply(seeds, gregexpr, text=seqs, ignore.case=TRUE)
        names(m1) = names(seeds)
        hasMatch = lapply(m1, function(x) sapply(x, function(y) y[y>0]))
        noMatches = sapply(hasMatch, function(x) sum(sapply(x, length)) > 0 )
        hasM = hasMatch[noMatches]
        whichM = lapply(hasM, function(x) {
                            hasMM = sapply(x, length) > 0
                            y = x[hasMM]
                            names(y) = names(seqs)[hasMM]
                            y})
        names(whichM) = names(seeds)[noMatches]
        return(whichM)
  }

\name{seedRegions}
\alias{seedRegions}
\title{ A function to retrieve the seed regions from microRNA sequences}
\description{
The seed region of a microRNA consists of a set of nucleotides at the
5' end of the microRNA, typically bases 2 through 7, although some times 8
is used.
}
\usage{
seedRegions(x, start = 2, stop = 7)
}
\arguments{
  \item{x}{ A vector of microRNA sequences. }
  \item{start}{ The start locations, can be a vector. }
  \item{stop}{ The stop locations, can be a vector. }
}
\details{
We use \code{\link{substr}} to extract these sequences.
}
\value{
 A vector of the same length as \code{x} with the substrings.
}
\author{ R. Gentleman }
\seealso{ \code{\link{substr}}}
\examples{
 data(hsSeqs)
 seedRegions(hsSeqs[1:5])
 seedRegions(hsSeqs[1:3], start=c(2,1,2), stop=c(8,7,9))
}
\keyword{ manip }

\name{mmSeqs}
\alias{mmSeqs}
\docType{data}
\title{ Mouse Mature microRNA Sequences}
\description{
 A set of mouse microRNA sequences.
}
\usage{data(mmSeqs)}
\format{
 A character vector.
}
\details{
 Each sequence represents a different mature mouse microRNA.
}
\source{
\url{http://microrna.sanger.ac.uk/sequences/index.shtml}
}
\references{
miRBase: microRNA sequences, targets and gene nomenclature.
Griffiths-Jones S, Grocock RJ, van Dongen S, Bateman A, Enright AJ.
NAR, 2006, 34, Database Issue, D140-D144

The microRNA Registry.
Griffiths-Jones S.
NAR, 2004, 32, Database Issue, D109-D111

}
\examples{
data(mmSeqs)
}
\keyword{datasets}

\name{matchSeeds}
\alias{matchSeeds}
\title{ A function to match seed regions to sequences. }
\description{
 Given an input set of seed regions and a set of sequences all locations
of the seed regions (exact matches) within the sequences are found.
}
\usage{
matchSeeds(seeds, seqs)
}
\arguments{
  \item{seeds}{ The seeds, or short sequences, to match. }
  \item{seqs}{ The sequences to find matches in. }
}
\details{
We presume that the problem is an exact matching problem and that
all sequences are in the correct orientation for that.  If, for
example, you start with seed regions from a microRNA (for \code{seeds})
 and 3'UTR sequences (for \code{seqs}), then you would want to reverse
complement one of the two sequences. And make sure all sequences
are either DNA or RNA.

 Names from either \code{seeds} or \code{seqs} are propogated, as much
as is possible.
}
\value{
A list containing one entry for each element of \code{seeds} that had
at least one match in one entry of \code{seqs}. Each element of this list
is a named vector containing the elements of \code{seqs} that the corresponding
seed has an exact match in.
}
\author{ R. Gentleman }
\seealso{\code{\link{seedRegions}}}
\examples{
library(Biostrings)
data(hsSeqs)
data(s3utr)
hSeedReg = seedRegions(hsSeqs)
comphSeed = as.character(reverseComplement(RNAStringSet(hSeedReg)))
comph = RNA2DNA(comphSeed)
mx = matchSeeds(comph, s3utr)
}
\keyword{ manip }

\name{get_selfhyb_subseq}
\alias{get_selfhyb_subseq}
\alias{show_selfhyb_counts}
\alias{show_selfhyb_lengths}

\title{Get Self-Hybridizing Subsequences}
\description{
  This function finds the longest self-hybridizing subsequences present
  in RNA or DNA sequences.
}
\usage{
get_selfhyb_subseq(seq, minlen, type = c("RNA", "DNA"))
show_selfhyb_counts(L)
show_selfhyb_lengths(L)
}

\arguments{
  \item{seq}{character vector of RNA or DNA sequences}
  \item{minlen}{an integer specifying the minimum length in bases of the
    self-hybridizing subsequences.  Subsequences with length less than
    \code{minlen} will be ignored.}
  \item{type}{one of \code{"RNA"} or \code{"DNA"} depending on the type of
    sequences provided in \code{seq}.  Note that you cannot mix RNA and
    DNA sequences.}
  \item{L}{The output of \code{get_selfhyp_subseq}.}
}

\details{
  \code{get_selfhyb_subseq} finds the longest self-hybridizing
  subsequences of the specified minimum length.

  These are defined to be the longest string that is found in both
  the input sequence, \code{seq}, and in its reverse complement.
}

\value{
  A list with an element for each sequence in \code{seq}.  The list will
  be named using \code{names(seq)}.

  Each element is itself a list with an element for each longest
  self-hybridizing subsequence (there can be more than one).  Each such
  element is yet another list with components:

  \item{starts}{integer vector giving the character start positions for
    the self-hybridizing subsequence in the sequence.}
  
  \item{rcstarts}{integer vector giving the character start positions
    for the reverse complement of the self-hybridizing subsequence in
    the sequence.}
}

\author{Seth Falcon}

\examples{
seqs = c(a="UGAGGUAGUAGGUUGUAUAGUU", b="UGAGGUAGUAGGUUGUGUGGUU",
         c="UGAGGUAGUAGGUUGUAUGGUU")

ans = get_selfhyb_subseq(seqs, minlen=3, type="RNA")
length(ans)

ans[["a"]]

show_selfhyb_counts(ans)
show_selfhyb_lengths(ans)
}

\keyword{ manip }

\name{RNA2DNA}
\alias{RNA2DNA}
\title{ A Function to translate RNA sequences into DNA sequences. }
\description{
RNA and DNA differ in that RNA uses uracil (U) and DNA uses thiamine (T),
this function translates an RNA sequence into a DNA sequence by translating
the characters.
}
\usage{
RNA2DNA(x)
}
\arguments{
  \item{x}{ A valid RNA sequence. }
}
\details{
No checking for validity of sequence is made, and the input sequence is
translated to upper case.
}
\value{
 A character vector, of the same length as \code{x} where all characters
are in upper case, and any instance of \code{U} in \code{x} is replaced
by a \code{T}.
}
\author{ R. Gentleman }
\seealso{ \code{\link{chartr}}}
\examples{
 input = c("AUCG", "uuac")
 RNA2DNA(input)
}
\keyword{ manip }

\name{s3utr}
\alias{s3utr}
\docType{data}
\title{ Test sequence data}
\description{
A vector of 3' UTR sequence data, the names correspond to Entrez Gene
IDs and the data were extracted using biomaRt.
}
\usage{data(s3utr)}
\format{
 A character vector, the values are the 3' UTR for a set of genes, the
names are Entrez Gene Identifiers.
}
\details{
The data were downloaded using the \code{getSequence} function in the
biomaRt package and duplicate strings removed. There remain some duplicated 
Entrez IDs but the reported 3' UTRs are different.
}
\examples{
data(s3utr)
}
\keyword{datasets}

\name{mmTargets}
\alias{mmTargets}
\docType{data}
\title{ Mouse microRNAs and their target IDs}
\description{
 A set of mouse microRNA names and their corresponding known targets
 given as ensembl Transcript IDs.
}
\usage{data(mmTargets)}
\format{
 A data frame of microRNAs and their target ensembl IDs as recovered
 from miRBase.  Additional columns are also provided to  give the
 Chromosome as well as the start and end position of the microRNA
 binding site, and the strand orientation (plus or minus).
}
\details{
 Each mapping represents a different mouse microRNA, paired with one
 viable target.  Other information about where the microRNA binds is
 also included.  Some microRNAs have multiple targets and so some
 microRNAs may be represented more than once.
}
\source{
\url{http://microrna.sanger.ac.uk/sequences/index.shtml}
}
\references{
miRBase: microRNA sequences, targets and gene nomenclature.
Griffiths-Jones S, Grocock RJ, van Dongen S, Bateman A, Enright AJ.
NAR, 2006, 34, Database Issue, D140-D144

The microRNA Registry.
Griffiths-Jones S.
NAR, 2004, 32, Database Issue, D109-D111

}
\examples{
data(mmTargets)
}
\keyword{datasets}
